package com.gharielsl.tf_villages.entity.model;

package ..deTemp.1750424548611;

import com.gharielsl.tf_villages.entity.TwilightTrader;
import com.gharielsl.tf_villages.entity.model.TwilightTraderAnimations;
import com.mojang.blaze3d.vertex.PoseStack;
import com.mojang.blaze3d.vertex.VertexConsumer;
import net.minecraft.client.model.HierarchicalModel;
import net.minecraft.client.model.geom.ModelLayerLocation;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.geom.PartPose;
import net.minecraft.client.model.geom.builders.CubeDeformation;
import net.minecraft.client.model.geom.builders.CubeListBuilder;
import net.minecraft.client.model.geom.builders.LayerDefinition;
import net.minecraft.client.model.geom.builders.MeshDefinition;
import net.minecraft.client.model.geom.builders.PartDefinition;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.util.Mth;
import net.minecraft.world.entity.Entity;

public class TwilightTraderModel<T extends TwilightTrader> extends HierarchicalModel<T> {
  public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(new ResourceLocation("tf_villages", "twilight_trader"), "main");
  
  private final ModelPart root;
  
  private final ModelPart head;
  
  private final ModelPart body;
  
  private final ModelPart left_arm;
  
  private final ModelPart right_arm;
  
  private final ModelPart bone3;
  
  private final ModelPart bone;
  
  private final ModelPart bone2;
  
  public TwilightTraderModel(ModelPart root) {
    this.root = root.m_171324_("root");
    this.head = this.root.m_171324_("head");
    this.body = this.root.m_171324_("body");
    this.left_arm = this.root.m_171324_("left_arm");
    this.right_arm = this.root.m_171324_("right_arm");
    this.bone3 = this.right_arm.m_171324_("bone3");
    this.bone = this.root.m_171324_("bone");
    this.bone2 = this.root.m_171324_("bone2");
  }
  
  public static LayerDefinition createBodyLayer() {
    MeshDefinition meshdefinition = new MeshDefinition();
    PartDefinition partdefinition = meshdefinition.m_171576_();
    PartDefinition root = partdefinition.m_171599_("root", CubeListBuilder.m_171558_(), PartPose.m_171419_(0.0F, 24.0F, 0.0F));
    PartDefinition head = root.m_171599_("head", CubeListBuilder.m_171558_().m_171514_(0, 13).m_171488_(-1.5F, -4.0F, -1.5F, 3.0F, 4.0F, 3.0F, new CubeDeformation(0.0F))
        .m_171514_(0, 7).m_171488_(-2.0F, -6.0F, -2.0F, 4.0F, 2.0F, 4.0F, new CubeDeformation(0.0F))
        .m_171514_(8, 20).m_171488_(1.5F, -3.0F, -1.0F, 1.0F, 2.0F, 1.0F, new CubeDeformation(0.0F))
        .m_171514_(4, 30).m_171488_(-2.5F, -3.0F, -1.0F, 1.0F, 2.0F, 1.0F, new CubeDeformation(0.0F)), PartPose.m_171423_(0.0F, -9.0F, 0.0F, 0.0873F, 0.0F, 0.0F));
    PartDefinition body = root.m_171599_("body", CubeListBuilder.m_171558_().m_171514_(16, 0).m_171488_(-1.5F, 0.0F, -1.0F, 3.0F, 4.0F, 2.0F, new CubeDeformation(0.0F)), PartPose.m_171423_(0.0F, -9.0F, 0.0F, 0.0873F, 0.0F, 0.0F));
    PartDefinition cube_r1 = body.m_171599_("cube_r1", CubeListBuilder.m_171558_().m_171514_(0, 0).m_171488_(-2.0F, -3.0F, 0.0F, 5.0F, 4.0F, 3.0F, new CubeDeformation(0.0F)), PartPose.m_171423_(-0.5F, 3.1F, -0.3F, 0.2182F, 0.0F, 0.0F));
    PartDefinition cube_r2 = body.m_171599_("cube_r2", CubeListBuilder.m_171558_().m_171514_(12, 13).m_171488_(-1.0F, -2.0F, 0.0F, 3.0F, 3.0F, 3.0F, new CubeDeformation(0.0F)), PartPose.m_171423_(-0.5F, 4.9F, -0.3F, 0.0873F, 0.0F, 0.0F));
    PartDefinition left_arm = root.m_171599_("left_arm", CubeListBuilder.m_171558_(), PartPose.m_171419_(2.0F, -8.5F, 0.0F));
    PartDefinition left_arm_r1 = left_arm.m_171599_("left_arm_r1", CubeListBuilder.m_171558_().m_171514_(24, 14).m_171488_(1.5F, -3.0F, -1.0F, 2.0F, 1.0F, 2.0F, new CubeDeformation(0.0F))
        .m_171514_(16, 6).m_171488_(1.5F, -6.0F, 1.0F, 2.0F, 4.0F, 2.0F, new CubeDeformation(0.0F)), PartPose.m_171423_(-1.7F, 5.5F, -2.0F, 0.0F, 0.0F, -0.0873F));
    PartDefinition right_arm = root.m_171599_("right_arm", CubeListBuilder.m_171558_(), PartPose.m_171419_(-2.0F, -8.5F, 0.0F));
    PartDefinition right_arm_r1 = right_arm.m_171599_("right_arm_r1", CubeListBuilder.m_171558_().m_171514_(24, 23).m_171488_(-3.5F, -3.0F, -1.0F, 2.0F, 1.0F, 2.0F, new CubeDeformation(0.0F))
        .m_171514_(0, 20).m_171488_(-3.5F, -6.0F, 1.0F, 2.0F, 4.0F, 2.0F, new CubeDeformation(0.0F)), PartPose.m_171423_(1.7F, 5.5F, -2.0F, 0.0F, 0.0F, 0.0873F));
    PartDefinition bone3 = right_arm.m_171599_("bone3", CubeListBuilder.m_171558_(), PartPose.m_171423_(0.0F, 3.0F, -3.0F, 0.1745F, 0.0F, 0.0F));
    PartDefinition cube_r3 = bone3.m_171599_("cube_r3", CubeListBuilder.m_171558_().m_171514_(16, 27).m_171488_(-3.0F, -2.0F, -1.0F, 1.0F, 1.0F, 2.0F, new CubeDeformation(0.0F)), PartPose.m_171423_(2.0F, -1.9F, -3.1F, 1.1781F, 0.0F, 0.0F));
    PartDefinition cube_r4 = bone3.m_171599_("cube_r4", CubeListBuilder.m_171558_().m_171514_(26, 4).m_171488_(-3.0F, -2.0F, 0.0F, 1.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)), PartPose.m_171423_(2.0F, -2.1F, -3.2F, 0.7418F, 0.0F, 0.0F));
    PartDefinition cube_r5 = bone3.m_171599_("cube_r5", CubeListBuilder.m_171558_().m_171514_(10, 27).m_171488_(-1.0F, -2.0F, -1.0F, 1.0F, 1.0F, 2.0F, new CubeDeformation(0.0F)), PartPose.m_171423_(0.0F, -3.4F, -0.5F, -0.1309F, 0.0F, 0.0F));
    PartDefinition cube_r6 = bone3.m_171599_("cube_r6", CubeListBuilder.m_171558_().m_171514_(24, 17).m_171488_(-1.0F, -2.0F, -1.0F, 1.0F, 1.0F, 1.0F, new CubeDeformation(0.0F)), PartPose.m_171423_(0.0F, -3.6F, -0.6F, 0.3054F, 0.0F, 0.0F));
    PartDefinition cube_r7 = bone3.m_171599_("cube_r7", CubeListBuilder.m_171558_().m_171514_(4, 27).m_171488_(-1.0F, -2.0F, -1.0F, 1.0F, 1.0F, 2.0F, new CubeDeformation(0.0F)), PartPose.m_171423_(0.0F, -3.0F, -2.0F, 0.5236F, 0.0F, 0.0F));
    PartDefinition cube_r8 = bone3.m_171599_("cube_r8", CubeListBuilder.m_171558_().m_171514_(0, 26).m_171488_(-1.0F, -6.0F, -1.0F, 1.0F, 6.0F, 1.0F, new CubeDeformation(0.0F)), PartPose.m_171423_(0.0F, 1.0F, 1.0F, 0.5236F, 0.0F, 0.0F));
    PartDefinition bone = root.m_171599_("bone", CubeListBuilder.m_171558_().m_171514_(12, 19).m_171488_(-1.0F, 0.0F, -2.4F, 2.0F, 1.0F, 3.0F, new CubeDeformation(0.0F))
        .m_171514_(26, 0).m_171488_(-1.1F, -2.0F, -1.0F, 2.0F, 3.0F, 1.0F, new CubeDeformation(0.0F)), PartPose.m_171419_(1.2F, -0.9F, 0.9F));
    PartDefinition cube_r9 = bone.m_171599_("cube_r9", CubeListBuilder.m_171558_().m_171514_(24, 6).m_171488_(-1.0F, -2.0F, 0.0F, 2.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)), PartPose.m_171423_(-0.3F, -2.0F, 0.0F, 0.2182F, 0.0F, 0.0F));
    PartDefinition cube_r10 = bone.m_171599_("cube_r10", CubeListBuilder.m_171558_().m_171514_(8, 23).m_171488_(-1.0F, -2.0F, 0.0F, 2.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)), PartPose.m_171423_(0.0F, -1.0F, -1.0F, 0.2182F, 0.0F, 0.0F));
    PartDefinition bone2 = root.m_171599_("bone2", CubeListBuilder.m_171558_().m_171514_(22, 19).m_171488_(-1.0F, 0.0F, -2.4F, 2.0F, 1.0F, 3.0F, new CubeDeformation(0.0F))
        .m_171514_(24, 26).m_171488_(-0.9F, -2.0F, -1.0F, 2.0F, 3.0F, 1.0F, new CubeDeformation(0.0F)), PartPose.m_171419_(-1.2F, -0.9F, 0.9F));
    PartDefinition cube_r11 = bone2.m_171599_("cube_r11", CubeListBuilder.m_171558_().m_171514_(24, 10).m_171488_(-1.0F, -2.0F, 0.0F, 2.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)), PartPose.m_171423_(0.3F, -2.0F, 0.0F, 0.2182F, 0.0F, 0.0F));
    PartDefinition cube_r12 = bone2.m_171599_("cube_r12", CubeListBuilder.m_171558_().m_171514_(16, 23).m_171488_(-1.0F, -2.0F, 0.0F, 2.0F, 2.0F, 2.0F, new CubeDeformation(0.0F)), PartPose.m_171423_(0.0F, -1.0F, -1.0F, 0.2182F, 0.0F, 0.0F));
    return LayerDefinition.m_171565_(meshdefinition, 64, 64);
  }
  
  private void applyHeadRotation(float pNetHeadYaw, float pHeadPitch, float pAgeInTicks) {
    pNetHeadYaw = Mth.m_14036_(pNetHeadYaw, -30.0F, 30.0F);
    pHeadPitch = Mth.m_14036_(pHeadPitch, -25.0F, 45.0F);
    this.head.f_104204_ = pNetHeadYaw * 0.017453292F;
    this.head.f_104203_ = pHeadPitch * 0.017453292F;
  }
  
  public void setupAnim(TwilightTrader entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
    m_142109_().m_171331_().forEach(ModelPart::m_233569_);
    applyHeadRotation(netHeadYaw, headPitch, ageInTicks);
    m_267799_(TwilightTraderAnimations.walk, limbSwing * 3.0F, limbSwingAmount * 3.0F, 2.0F, 2.5F);
    m_233385_(entity.idleAnimationState, TwilightTraderAnimations.idle, ageInTicks, 1.0F);
  }
  
  public void m_7695_(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay, float red, float green, float blue, float alpha) {
    this.root.m_104306_(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
  }
  
  public ModelPart m_142109_() {
    return this.root;
  }
}
